#!/opt/bin/wish4.2 -f
#

wm title . "Ulab Account Generator"


# Dialog chapter
proc GetValue { string hide } {
	global prompt
	set f [toplevel .prompt -borderwidth 10 -width 600]
	message $f.msg -width 500 -text $string
	set prompt(result) {}
	if { $hide } {
		entry $f.entry -show * -textvariable prompt(result)
	} else {
		entry $f.entry -textvariable prompt(result)
	}
	set b [frame $f.buttons -bd 10]
	pack $f.msg $f.entry $f.buttons -side top -fill x
	
	button $b.ok -text OK -command {set prompt(ok) 1} \
		-underline 0
	button $b.cancel -text Cancel -command {set prompt(ok) 0} \
		-underline 0
	pack $b.ok -side left
	pack $b.cancel -side right

	foreach w [list $f.entry $b.ok $b.cancel] {
	    bindtags $w [list .prompt [winfo class $w] $w all]
	}
	bind .prompt <Alt-o> "focus $b.ok ; break"
	bind .prompt <Alt-c> "focus $b.cancel ; break"
	bind .prompt <Alt-Key> break
	bind .prompt <Return> {set prompt(ok) 1}
	bind .prompt <Control-c> {set prompt(ok) 0}

	focus $f.entry
	grab $f
	tkwait variable prompt(ok)
	grab release $f
	destroy $f
	if {$prompt(ok)} {
		return $prompt(result)
	} else {
		return {}
	}
}

# Listbox chapter
proc ScrolledListbox2 { parent args } {
	frame $parent
	# Create listbox attached to scrollbars, pass thru $args
	eval {listbox $parent.list \
		-yscrollcommand [list $parent.sy set] \
		-xscrollcommand [list $parent.sx set]} $args
	scrollbar $parent.sy -orient vertical \
		-command [list $parent.list yview]
	# Create extra frame to hold pad and horizontal scrollbar
	frame $parent.bottom
	scrollbar $parent.sx -orient horizontal \
		-command [list $parent.list xview]
	# Create padding based on the scrollbar width and border
	set pad [expr [$parent.sy cget -width] + 2* \
		([$parent.sy cget -bd] + \
		 [$parent.sy cget -highlightthickness])]
	frame $parent.pad -width $pad -height $pad
	# Arrange everything in the parent frame
	pack $parent.bottom -side bottom -fill x
	pack $parent.pad -in $parent.bottom -side right
	pack $parent.sx -in $parent.bottom -side bottom -fill x
	pack $parent.sy -side right -fill y
	pack $parent.list -side left -fill both -expand true

	return $parent.list
}

proc FileSelect { y } {
	global rfile file_index rosterdir first last ssn

	set w .all.g.list
	#puts "y is $y"
	$w delete 0 end
	set item [.all.f.list nearest $y]
	#puts "item is $item"
	set file_index $item

	set i 0
	set j 0
	set InFile [open $rosterdir/$rfile($item) r ]
	foreach line [split [read $InFile] \n] {
		if { $j < 4 } {
			incr j
		} else {
			regexp {[ ]*([0-9]*)[ ]*([^ ]*)[ ]*([^ ]*)[^0-9]*([-0-9]*)} \
				 $line match k last($i) first($i) ssn($i)
			if {[regexp {(.)} "$last($i)" match k]== 0 } {
				break
		    } else {
				.all.g.list insert end "$last($i), $first($i)"
				incr i
				incr j
			}
		}
	}
	close $InFile
}

proc pwok { pw } {
	
	set lc 0
	set uc 0
	set num 0
	set spec 0
	set i 0
	set sea1 0
	set island 0
	set sea2 0
	if { [string length $pw] < 6 } {
		tk_messageBox -icon info -type ok -parent .all -title "Password Rule" \
			-message "Too short it needs to be at least 6 characters"
		#puts "Too short it needs to be at least 6 characters"
		return 0
	}
	while { $i < 8 } {
		if {[regexp {(.)(.+)} "$pw" match letter($i) rest] < 2 } {
			if {[regexp {(.)} "$pw" match letter($i)] == 0 } {
				break;
			}
			set pw {}
		}
		set pw "$rest"
		if { [string match {[a-z]} $letter($i)] } {
			set lc 1
		}
		if { [string match {[A-Z]} $letter($i)] } {
			set uc 1
		}
		if { [string match {[0-9]} $letter($i)] } {
			set num 1
			if { $sea1 == 1 } {
				set island 1
			}
		} else {
			if { $island == 1 } {
				set sea2 1
			}
			set sea1 1
		}
		#if { [string match {[!-@\[-`\{-~]} $letter($i)] } {
		#	set spec 1
		#}
		#puts "$i is $letter($i)"
		incr i
	}
	if { $i < 6 } {
		tk_messageBox -icon info -type ok -parent .all -title "Password Rule" \
			-message "Too short it needs to be at least 6 characters"
		#puts "Too short it needs to be at least 6 characters"
		return 0
	}
	if { $lc == 0 } {
		tk_messageBox -icon info -type ok -parent .all -title "Password Rule" \
			-message "A password needs to have lower case letters"
		#puts "A password needs to have lower case letters"
		return 0
	}
	if { $uc == 0 } {
		tk_messageBox -icon info -type ok -parent .all -title "Password Rule" \
			-message "A password needs to have upper case letters"
		#puts "A password needs to have upper case letters"
		return 0
	}
	#if { $spec == 0 } {
	#	tk_messageBox -icon info -type ok -parent .all -title "Password Rule" \
	#	puts "A password needs to have special characters"
	#	return 0
	#}
	if { $num == 0 } {
		tk_messageBox -icon info -type ok -parent .all -title "Password Rule" \
			-message "A password needs to have digit characters"
		#puts "A password needs to have digit characters"
		return 0
	}
	if { $sea2 == 0 } {
		tk_messageBox -icon info -type ok -parent .all -title "Password Rule" \
			-message "A password needs to have non-terminal digit characters"
		#puts "A password needs to have non-terminal digit characters"
		return 0
	}
	return 1
}

proc AlreadyAccounted { login } {
	#puts "login is $login"
	set InFile [open ../nis/passwd r ]
	foreach line [split [read $InFile] \n] {
		set answer [string first $login $line]
		#puts "$answer for $line"
		if { $answer == 0 } {
			#puts "match found $login already has an account\n$line"
			close $InFile
			return 1
		}
	}
	close $InFile
	return 0
}

proc LoginName { first last } {
	set one [string index $first 0]
	set two [string range $last 0 6]
	set all $one$two
	string tolower $all
}

proc StudentSelect { y } {
	global first last ssn top
	set stud_index [.all.g.list nearest $y]
	#puts "$stud_index is $first($stud_index) $last($stud_index) with $ssn($stud_index)"
	set login [LoginName $first($stud_index) $last($stud_index)]
	#puts "The login name or user name is $login"
	if { [AlreadyAccounted $login] == 1 } {
		tk_messageBox -icon error -type ok -parent .all \
			-title "Duplicate Account \"$login\"" \
			-message "If you have forgotten your password,\n or if this is not your account,\n you need to see a member of the system group"
		#puts "If you have forgotten your password,\n or this is not your account,\n you need to see one of the system group"
		return 1
	}
	set test [GetValue  "Social Security Number" true]
	set one {}
	set two {}
	set three {}
	regexp {([0-9][0-9][0-9])-*([0-9][0-9])-*([0-9][0-9][0-9][0-9])} \
		$test match one two three
	set test $one-$two-$three
	if { [string match $test $ssn($stud_index)] } {
		#puts "SSN Matches"
		set pw1 "[GetValue  "Password" true]"
		while { [pwok "$pw1"] == 0 } {
			set pw1 "[ GetValue "Better Password" true ]"
		}
		set pw2 "[GetValue  "Re-Type Password" true]"
		if { [string match "$pw1" "$pw2" ] } {
			#puts "Password Match Now Generating Account"
			set pw3 [exec ./crypt $pw1]
			#puts "$pw3"
			exec ./addone $first($stud_index) $last($stud_index) $pw3 > dump.out
			set trash [exec ./logit.sh $first($stud_index) $last($stud_index)]
			#puts [exec ./logit.sh $first($stud_index) $last($stud_index)]
			#puts "Done Account $login Added"
			tk_messageBox -icon info -type ok -parent .all -title "Success" \
				-message "Your Account with Login \"$login\" is ready for use"
		} else {
			#puts "Sorry Passwords do not match"
			tk_messageBox -icon error -type ok -parent .all \
				 -title "Typing Error" \
				-message "Sorry Passwords do not match"
		}
	} else {
		#puts "Sorry Wrong Social Security Number"
		tk_messageBox -icon error -type ok -parent .all -title "SSN Error" \
			-message "Sorry Wrong Social Security Number"
	}
}

frame .all
# This needs to be run in the account/src directory.
set rosterdir "../db"

ScrolledListbox2 .all.f -width 10 -height 35 -setgrid true
pack .all.f -expand true -fill both -side left
bind .all.f.list <ButtonRelease-1> {FileSelect %y}

set i 0
foreach file [glob $rosterdir/* ] {
	# strip down to just the file name
	regexp {.*/([^/]*)$} $file match thing
	set rfile($i) $thing
	.all.f.list insert end $thing
	incr i
}

ScrolledListbox2 .all.g -width 20 -height 35 -setgrid true
bind .all.g.list <ButtonRelease-1> {StudentSelect %y}
pack .all.g -expand true -fill both -side left
button .all.q -text Quit -command "destroy ."
pack .all.q -side right -expand 1

pack .all


