#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <errno.h>

int cp (char * src, char * dst ) {
	pid_t pid, qid;
	char* childArgV[4];
	childArgV[0] = "/bin/cp";
	childArgV[1] = src;
	childArgV[2] = dst;
	childArgV[3] = NULL;

	if ( (pid = fork()) == 0 ) { /* child */
		execv("/bin/cp", childArgV);
		/* cannot get here */
	} else { /* parent */
		int status;
		while ( qid = wait ( & status ) ) {
			if ( ( qid == -1 ) && (errno == ECHILD) ) {
				fprintf ( stderr, "Parent has no children" );
				return 1;
			}
			if ( qid == pid )
				break;
		}
		return (status & 0xff00)>>8;
	}
}

#if MAIN
main() {
	return cp ( "atrashfile", "/atrashfile" );
}
#endif

